#!/bin/bash
#/**
#        reduceimage
#@brief  Reduce el archivo de la imagen a tamaño datos + 500M
#@param 1 imagen
#@param 2 extension [ img|diff ] opcional, por defecto img
#@return  
#@exception OG_ERR_FORMAT     # 1 formato incorrecto.
#@exception OG_ERR_NOTFOUND # 2 Fichero o dispositivo no encontrado
#@exception OG_ERR_LOCKED          # 4 Partición o fichero bloqueado
#@exception OG_ERR_DONTSYNC_IMAGE  #71 Imagen no sincronizable (es monolitica)
#@version 1.0 - Reducir tamaño imagen sincronizable
#@author  Irina Gomez
#@date   2013-05-23
#*/ ##
BASEDIR=/opt/opengnsys
REPODIR="$BASEDIR/images"
REPOLOG=$BASEDIR/log/ogAdmRepo.log
source $BASEDIR/client/etc/lang.$LANG.conf

PROG="$(basename $0)"
# Si se solicita, mostrar ayuda.
if [ "$*" == "help" ]; then
    echo -e " $PROG: $MSG_HELP_ogReduceImage \n" \
            "$MSG_FORMAT: $PROG nombre_image [ img|diff ] \n" \
            "base -> $PROG Windows7 \n" \
	    "diff -> $PROG Ubuntu12 diff"
   exit 0
fi

[ $# -lt 1 ] && echo -e "$PROG: Error: $MSG_ERR_FORMAT \n     $MSG_FORMAT: $PROG image [ img | diff ]" && exit 1

if [ "$USER" != "root" ]; then
        echo "$PROG: Error: solo ejecutable por root" >&2
        exit 1
fi

[ "$2" == "" -o "$2" == "img" ] && IMGEXT="img" || IMGEXT="img.diff"
# Comprobamos que existe imagen y que no este bloqueada
IMGFILE="$REPODIR/$1.$IMGEXT"
[ ! -f $IMGFILE ] && echo "$PROG: Error: $MSG_ERR_NOTFOUND $1 $IMGEXT" && exit 2
[ -f $IMGFILE.lock ] && echo "$PROG: Error: $MSG_ERR_LOCKED $1 $IMGEXT" && exit 4 

# Comprobar que la imagen  es sincronizable
if ! file $IMGFILE | grep " BTRFS Filesystem" >/dev/null ; then
	echo "$PROG: Error: $MSG_ERR_DONTSYNC_IMAGE $1 $2"
	exit 71
fi

touch $IMGFILE.lock
echo -ne REDUCE_IMAGE "$1" ${IMGEXT#*\.} | /opt/opengnsys/sbin/ogAdmRepoAux
echo "Los resultado se registran en $REPOLOG. "

rm $IMGFILE.lock
